#include <stdio.h>
#include <intrinsic.h>

#define FAST_CRC16
//#define SLOW_CRC16

#pragma segment="INTVEC" __code

extern unsigned short __checksum;
extern unsigned int ROMSTART;
extern unsigned int ROMEND;

extern unsigned short slow_crc16(unsigned short,unsigned char *,unsigned int);
extern unsigned short fast_crc16(unsigned short,unsigned char *,unsigned int);

const int zero=0;
void main(void)
{
     unsigned short sum=0;

#ifdef SLOW_CRC16
     sum = slow_crc16(sum,(unsigned char *)__segment_begin("INTVEC"), 0x40);
     sum = slow_crc16(sum,(unsigned char *)&ROMSTART, (unsigned int)&ROMEND -2 -(unsigned int)&ROMSTART +1);
     sum = slow_crc16(sum,(unsigned char *)&zero, 2);
#elif defined FAST_CRC16
     sum = fast_crc16(sum,(unsigned char *)__segment_begin("INTVEC"), 0x40);
     sum = fast_crc16(sum,(unsigned char *)&ROMSTART, (unsigned int)&ROMEND -2 -(unsigned int)&ROMSTART +1);
#endif
     if(sum!=__checksum)
          printf("Checksum failed: 0x%hX (counted) vs 0x%hX (from xlink)\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
